//
//  NewsfeedInteractor.swift
//  VKExt
//
//  Created programmist_NA on 25.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import SwiftyJSON
import SwiftyVK

class NewsfeedInteractor: NewsfeedInteractorProtocol {
    weak var presenter: NewsfeedPresenterProtocol?
    var service: NewsfeedService?

    func start(request: Newsfeed.Model.Request.RequestType) {
        makeRequest(request: request)
    }
    
    func makeRequest(request: Newsfeed.Model.Request.RequestType) {
        if service == nil {
            service = NewsfeedService()
        }
        
        switch request {
        case .getStories:
            service?.getStories(completion: { [weak self] (storiesIds, response) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentStories(storie: response, storiesIds: storiesIds))
            })
        case .getNewsfeed:
            self.presenter?.presentData(response: .presentFooterLoader)
            service?.getFeed(completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentNewsfeed(feed: feed, revealdedPostIds: revealedPostIds))
                }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        case .revealPostIds(let postId):
            service?.revealPostIds(forPostId: postId, completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentNewsfeed(feed: feed, revealdedPostIds: revealedPostIds))
            })
        case .getNextBatch:
            self.presenter?.presentData(response: .presentFooterLoader)
            service?.getNextBatch(completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentNewsfeed(feed: feed, revealdedPostIds: revealedPostIds))
                }, failed: { [weak self] error in
                        guard let self = self else { return }
                        self.presenter?.presentData(response: .presentFooterError(message: error))
                })
        case .like(let postId, let sourceId, let type):
            service?.addLikePost(type: type, ownerId: sourceId, itemId: postId)
        case .unlike(let postId, let sourceId, let type):
            service?.deleteLikePost(type: type, ownerId: sourceId, itemId: postId)
        default:
            break
        }
    }
}
